import { ERROR_BOX_TYPES } from './ERROR_BOX_TYPES';
import { Hotkey } from './shapes';
import { WebRequestHeaderConfig } from './WebRequestHeader';
import { WebOptions } from './WebOptions';
import { PreloadScript } from './PreloadScript';
import { Layout } from './Layout';
export interface WindowOptions extends WebOptions {
    'accelerator'?: {
        devtools: boolean;
        reload: boolean;
        reloadIgnoringCache: boolean;
        zoom: boolean;
    };
    'alphaMask'?: {
        blue: number;
        green: number;
        red: number;
    };
    'alwaysOnBottom'?: boolean;
    'alwaysOnTop'?: boolean;
    'api'?: any;
    'applicationIcon'?: string;
    'appLogFlushInterval'?: number;
    'aspectRatio'?: number;
    'autoShow'?: boolean;
    'backgroundColor'?: string;
    'backgroundThrottling'?: boolean;
    'center'?: boolean;
    'contentNavigation'?: null | {
        whitelist?: string[];
        blacklist?: string[];
    };
    'contextMenu'?: boolean;
    'contextMenuSettings'?: {
        enable: boolean;
        devtools?: boolean;
        reload?: boolean;
    };
    'cornerRounding'?: {
        height: number;
        width: number;
    };
    'customData'?: string;
    'customRequestHeaders'?: WebRequestHeaderConfig[];
    'defaultCentered'?: boolean;
    'defaultHeight'?: number;
    'defaultLeft'?: number;
    'defaultTop'?: number;
    'defaultWidth'?: number;
    'description'?: string;
    'disableIabSecureLogging'?: boolean;
    'draggable'?: boolean;
    'enableAppLogging'?: boolean;
    'enable-plugins'?: boolean;
    'enableLargerThanScreen'?: boolean;
    'exitOnClose'?: boolean;
    'experimental'?: any;
    'fdc3Api'?: boolean;
    'fdc3Manifest'?: string;
    'frame'?: boolean;
    'frameConnect'?: 'all' | 'last' | 'main-window';
    'hasLoaded'?: boolean;
    'height'?: number;
    'hideOnBlur'?: boolean;
    'hideOnClose'?: boolean;
    'hideWhileChildrenVisible'?: boolean;
    'hotkeys'?: Hotkey[];
    'icon'?: string;
    'isRawWindowOpen'?: boolean;
    'launchExternal'?: string;
    'layout'?: Layout;
    'loadErrorMessage'?: string;
    'maxHeight'?: number;
    'maximizable'?: boolean;
    'maxWidth'?: number;
    'minHeight'?: number;
    'minimizable'?: boolean;
    'minWidth'?: number;
    'name': string;
    'nonPersistent'?: boolean;
    'nonPersistant'?: boolean;
    'opacity'?: number;
    'plugins'?: boolean;
    'preload'?: string | PreloadScript[];
    'preloadScripts'?: PreloadScript[];
    'resizable'?: boolean;
    'resize'?: boolean;
    'resizeRegion'?: {
        bottomRightCorner: number;
        size: number;
        sides?: {
            top?: boolean;
            right?: boolean;
            bottom?: boolean;
            left?: boolean;
        };
    };
    'saveWindowState'?: boolean;
    'shadow'?: boolean;
    'show'?: boolean;
    'showBackgroundImages'?: boolean;
    'showTaskbarIcon'?: boolean;
    'skipTaskbar'?: boolean;
    'smallWindow'?: boolean;
    'state'?: 'maximized' | 'minimized' | 'normal';
    'taskbarIcon'?: string;
    'taskbarIconGroup'?: string;
    'title'?: string;
    'toShowOnRun'?: boolean;
    'transparent'?: boolean;
    '_type'?: ERROR_BOX_TYPES;
    'url'?: string;
    'uuid': string;
    'waitForPageLoad'?: boolean;
    'webPreferences'?: {
        nodeIntegration: boolean;
        plugins: boolean;
    };
    'width'?: number;
    'x'?: number;
    'y'?: number;
}
